SystemOrganization addCategory: #'Puzzles-GUI'!
SystemOrganization addCategory: #'Puzzles-Core'!
SystemOrganization addCategory: #Puzzles!

Matrix subclass: #IrregularGrid
	instanceVariableNames: 'regions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Puzzles-Core'!

!IrregularGrid class methodsFor: 'instance creation' stamp: 'mg 6/27/2014 11:17'!
newFromFile: aFileName

	| file charList grid puzzleSize |
	charList := OrderedCollection new.
	file := MultiByteFileStream fileNamed: aFileName.
	file upToEnd asString substrings
		collect: [:row | row do: [:char | charList add: char]].
	puzzleSize := charList size sqrt.
	file close.
	grid := IrregularGrid new: puzzleSize element: 0.
	grid buildRegionsFrom: charList.

	^ grid! !

!IrregularGrid methodsFor: 'initialize-release' stamp: 'mg 6/27/2014 11:19'!
buildRegionsFrom: aCharacterList

	regions := Matrix new: self rowCount tabulate: [:i :j | aCharacterList at: (j \\ 10 + (i-1*9))].! !

!IrregularGrid methodsFor: 'initialize-release' stamp: 'mg 6/27/2014 11:16'!
initialize

	super initialize.
	regions := Matrix new: 9.! !

!IrregularGrid methodsFor: 'accessing' stamp: 'mg 6/27/2014 11:26'!
regionWithIdentifier: aCharacter

	| region |
	region := OrderedCollection new.
	regions withIndicesDo: [:val :row :col | 
		val = aCharacter ifTrue: [region add: (self at: row at: col)]].
	^ region! !

!IrregularGrid methodsFor: 'accessing' stamp: 'mg 6/27/2014 11:35'!
regions

	^ regions! !

SimpleBorder subclass: #OneLineBorderStyle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Puzzles-GUI'!

!OneLineBorderStyle methodsFor: 'drawing' stamp: 'mg 6/27/2014 15:22'!
frameRectangle: aRectangle on: aCanvas
	"The top line is drawn as border (higher width)."
	aCanvas line: aRectangle topLeft to: aRectangle topRight width: 5 color: Color black.
	aCanvas frameAndFillRectangle: aRectangle
		fillColor: Color transparent
		borderWidth: 1
		topLeftColor: Color black
		bottomRightColor: Color black.! !

BorderedMorph subclass: #IrregularCell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Puzzles-GUI'!

!IrregularCell methodsFor: 'rotating' stamp: 'mg 6/27/2014 15:51'!
borderBottom

	self heading: 180.! !

!IrregularCell methodsFor: 'rotating' stamp: 'mg 6/27/2014 15:50'!
borderLeft

	self heading: 270.! !

!IrregularCell methodsFor: 'rotating' stamp: 'mg 6/27/2014 15:50'!
borderRight

	self heading: 90.! !

!IrregularCell methodsFor: 'rotating' stamp: 'mg 6/27/2014 15:51'!
borderTop

	self heading: 0.! !

!IrregularCell methodsFor: 'initialization' stamp: 'mg 6/27/2014 15:49'!
initialize

	| style |
	super initialize.
	style := OneLineBorderStyle new.
	style width: 1.
	style color: Color red.
	self borderStyle: style.
	self color: Color white. 
	self width: 50; height: 50.! !
